//
// Procedures and functions
//
program QuickSortDemo;

const
  N = 1000;
type
  TArray = array[ 1..N ] of Integer;

procedure QuickSort( var A : TArray; L, H : Integer );
var
  I, J, X, temp : Integer;
begin
  I := L;
  J := H;
  X := A[ ( I + J ) div 2 ];
  repeat
    while A[ I ] < X do I := I + 1;
    while X < A[ J ] do J := J - 1;
    if I <= J then
    begin 
      temp := A[ I ];
      A[ I ] := A[ J ];
      A[ J ] := temp; 
      I := I + 1;
      J := J - 1;
    end;
  until I > J;
  if L < J then QuickSort( A, L, J );
  if I < H then QuickSort( A, I, H );
end;

var
  I : Integer;
  Hour1, Min1, Sec1, MSec1, Hour2, Min2, Sec2, MSec2 : Integer;
  A : TArray;
begin
  DecodeTime( Now, Hour1, Min1, Sec1, MSec1 );

  for I:=1 to N do A[ I ] := Random( 500 );

  QuickSort( A, 1, N );

  for I:=1 to N do write( A[ I ], ' ' );

  writeln;

  DecodeTime( Now, Hour2, Min2, Sec2, MSec2 );

  writeln( Hour1, ' ', Min1, ' ', Sec1, ' ', MSec1 );
  writeln( Hour2, ' ', Min2, ' ', Sec2, ' ', MSec2 );
end.
